base/urls.py
from django.conf import settings
from django.contrib import admin
from django.contrib.auth.views import LoginView, LogoutView
from django.urls import path, include, re_path, reverse_lazy
from django.views.generic import TemplateView
from django.views.static import serve

urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('users.urls')),
    path('logged_out/', TemplateView.as_view(template_name="registration/logged_out.html"), name="logged_out"),
    path('login/', LoginView.as_view(), name="login"),
    path('logout/', LogoutView.as_view(next_page=reverse_lazy("logged_out")), name="logout"),
    path('event/', include('event.urls')),
    path('rental/', include('rental.urls')),
    path('communication/', include('communication.urls')),
    path('i18n/', include('django.conf.urls.i18n')),
    path('', TemplateView.as_view(template_name="base/homepage.html"), name="homepage"),

]

if settings.DEBUG:
    urlpatterns.append(re_path(r'^media/(?P<path>.*)$',
                               serve,
                               {'document_root': settings.MEDIA_ROOT, 'show_indexes': True}))

event/urls.py
from django.urls import path
from event.views import EventCreateView, EventListView, EventDetailView, TeamDetailView, TeamCreateView, TeamActionView, \
    EventActionView, EventUpdateView, TeamUpdateView

urlpatterns = [
    path('create/', EventCreateView.as_view(), name='event_create'),
    path('list/', EventListView.as_view(), name='event_list'),
    path('detail/<int:event_id>/', EventDetailView.as_view(), name='event_detail'),
    path('detail/<int:event_id>/remove/', EventActionView.as_view(action="remove", validate=True), name='event_remove'),
    path('detail/<int:event_id>/edit/', EventActionView.as_view(action="edit"), name='event_edit'),
    path('detail/<int:event_id>/edit_form/', EventUpdateView.as_view(), name='event_edit_form'),
    path('detail/<int:event_id>/team/create/', TeamCreateView.as_view(), name='team_create'),
    path('detail/<int:event_id>/team/<int:team_id>/', TeamDetailView.as_view(), name='team_detail'),
    path('detail/<int:event_id>/team/<int:team_id>/join/', TeamActionView.as_view(action="join"), name='team_join'),
    path('detail/<int:event_id>/team/<int:team_id>/edit/', TeamActionView.as_view(action="edit"), name='team_edit'),
    path('detail/<int:event_id>/team/<int:team_id>/edit_form/', TeamUpdateView.as_view(), name='team_edit_form'),
    path('detail/<int:event_id>/team/<int:team_id>/leave/', TeamActionView.as_view(action="leave"), name='team_leave'),
    path('detail/<int:event_id>/team/<int:team_id>/disband/',
         TeamActionView.as_view(action="disband", validate=True), name='team_disband'),
]

event/models.py
from django.db import models
from django.conf import settings
from django.utils.translation import gettext_lazy as _


class Event(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE)
    name = models.CharField(max_length=60)
    location = models.CharField(max_length=20)
    date = models.DateField()
    created = models.DateTimeField(auto_now_add=True)
    updated = models.DateTimeField(auto_now=True)
    description = models.TextField(max_length=300)

    def __str__(self):
        return self.name


class EventComment(models.Model):
    event = models.ForeignKey(Event, on_delete=models.CASCADE, related_name='comments', verbose_name=_("Event"))
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.SET_NULL, null=True, verbose_name=_("Owner"))
    parent = models.ForeignKey('self', on_delete=models.CASCADE, related_name='replies', blank=True, null=True,
                               verbose_name=_("Parent"))
    comment = models.TextField(max_length=140, verbose_name=_("Comment"))
    created = models.DateTimeField(auto_now_add=True, verbose_name=_("Created"))
    updated = models.DateTimeField(auto_now=True, verbose_name=_("Updated"))
    image = models.ImageField(blank=True, null=True, verbose_name=_("Image"))

    def __str__(self):
        return self.comment


class Participation(models.Model):
    participant = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, verbose_name=_("Participant"))
    event = models.ForeignKey(Event, on_delete=models.CASCADE, verbose_name=_("Event"))
    team = models.ForeignKey('Team', on_delete=models.SET_NULL, null=True, verbose_name=_("Team"))


class Team(models.Model):
    owner = models.ForeignKey(settings.AUTH_USER_MODEL, on_delete=models.CASCADE, verbose_name=_("Owner"))
    event = models.ForeignKey(Event, on_delete=models.CASCADE, verbose_name=_("Event"))
    name = models.CharField(max_length=32, verbose_name=_("Name"))

    def __str__(self):
        return self.name

event/forms.py
from django import forms
from event.models import Event, Team, Participation
from users.forms import RealDateInput


class EventCreateForm(forms.ModelForm):
    date = forms.DateField(widget=RealDateInput, input_formats=['%Y-%m-%d'])

    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        super().__init__(*args, **kwargs)

    def save(self, commit=True):
        obj = super().save(commit=False)
        obj.owner = self.request.user
        obj.save(commit)
        return obj

    class Meta:
        model = Event
        fields = ['name', 'date', 'location', 'description', ]


class EventUpdateForm(forms.ModelForm):
    date = forms.DateField(widget=RealDateInput, input_formats=['%Y-%m-%d'])
    class Meta:
        model = Event
        fields = ['name', 'date', 'location', 'description']


class TeamCreateForm(forms.ModelForm):
    def __init__(self, *args, **kwargs):
        self.request = kwargs.pop("request")
        self.event = kwargs.pop("event")
        super().__init__(*args, **kwargs)

    def save(self, commit=True):
        obj = super().save(commit=False)
        obj.event = self.event
        obj.owner = self.request.user
        obj.save(True)
        Participation.objects.create(participant=obj.owner, event=self.event, team=obj)
        return obj

    class Meta:
        model = Team
        fields = ['name']


class TeamUpdateForm(forms.ModelForm):
    class Meta:
        model = Team
        fields = ['name']

event/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render
from django.urls import reverse_lazy, reverse
from django.utils.translation import gettext_noop

from event.models import Event, Team, Participation
from django.views.generic import CreateView, ListView, DetailView, RedirectView, UpdateView
from event.forms import EventCreateForm, TeamCreateForm, EventUpdateForm, TeamUpdateForm


class EventListView(ListView):
    model = Event


class EventCreateView(LoginRequiredMixin, CreateView):
    model = Event
    form_class = EventCreateForm
    success_url = reverse_lazy("event_list")

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs["request"] = self.request
        return kwargs


class EventDetailView(DetailView):
    model = Event
    pk_url_kwarg = "event_id"


class EventUpdateView(LoginRequiredMixin, UpdateView):
    model = Event
    form_class = EventUpdateForm
    success_url = reverse_lazy("event_list")
    pk_url_kwarg = "event_id"

    def get_success_url(self):
        return reverse("event_detail", kwargs={"event_id": self.kwargs["event_id"]})


class EventActionView(LoginRequiredMixin, RedirectView):
    action = None
    validate = False
    url = None

    def get_redirect_url(self, *args, **kwargs):
        return self.url or reverse("event_detail", kwargs={'event_id': self.kwargs["event_id"]})

    def apply_action(self, action):
        if action == gettext_noop("remove"):
            self.event.delete()
            self.url = reverse("event_list")
        elif action == gettext_noop("edit"):
            self.url = reverse("event_edit_form", kwargs={'event_id': self.kwargs["event_id"]})
        else:
            pass

    def get(self, request, *args, **kwargs):
        self.event = Event.objects.get(id=self.kwargs["event_id"])
        if request.GET.get("valid") == 'false':
            return super().get(request, *args, **kwargs)
        elif self.validate and not request.GET.get("valid") == 'true':
            return render(request, "base/validate.html", {"action": self.action, "object": self.event})
        else:
            self.apply_action(self.action)
            return super().get(request, *args, **kwargs)


class TeamCreateView(LoginRequiredMixin, CreateView):
    model = Team
    form_class = TeamCreateForm
    pk_url_kwarg = "team_id"

    def get_success_url(self):
        return reverse("team_detail", kwargs={"event_id": self.kwargs["event_id"], "team_id": self.object.id})

    def get_form_kwargs(self):
        kwargs = super().get_form_kwargs()
        kwargs["request"] = self.request
        kwargs["event"] = Event.objects.get(id=self.kwargs["event_id"])
        return kwargs


class TeamDetailView(ListView):
    model = Participation
    pk_url_kwarg = "team_id"

    def get_queryset(self):
        return super().get_queryset().filter(team_id=self.kwargs["team_id"], team__event_id=self.kwargs["event_id"])

    def get_context_data(self, *, object_list=None, **kwargs):
        context = super().get_context_data(object_list=object_list, **kwargs)
        context["team"] = Team.objects.get(id=self.kwargs["team_id"])
        context["event"] = Event.objects.get(id=self.kwargs["event_id"])
        context["users"] = self.object_list.values_list("participant_id", flat=True)
        return context


class TeamUpdateView(LoginRequiredMixin, UpdateView):
    model = Team
    form_class = TeamUpdateForm
    pk_url_kwarg = "team_id"

    def get_success_url(self):
        return reverse("team_detail", kwargs={"event_id": self.kwargs["event_id"], "team_id": self.object.id})


class TeamActionView(LoginRequiredMixin, RedirectView):
    action = None
    validate = False
    url = None

    def get_redirect_url(self, *args, **kwargs):
        return self.url or reverse("team_detail",
                                   kwargs={'event_id': self.kwargs["event_id"], 'team_id': self.kwargs["team_id"]})

    def apply_action(self, action):
        if action == gettext_noop("join"):
            Participation.objects.create(participant=self.request.user, event=self.event, team=self.team)
        elif action == gettext_noop("edit"):
            self.url = reverse("team_edit_form",
                               kwargs={'event_id': self.kwargs["event_id"], 'team_id': self.kwargs["team_id"]})
        elif action == gettext_noop("leave"):
            Participation.objects.filter(participant=self.request.user, event=self.event, team=self.team).delete()
        elif action == gettext_noop("disband"):
            self.team.delete()
            self.url = reverse("event_detail", kwargs={'event_id': self.kwargs["event_id"]})
        else:
            pass

    def get(self, request, *args, **kwargs):
        self.team = Team.objects.get(id=self.kwargs["team_id"])
        self.event = Event.objects.get(id=self.kwargs["event_id"])
        if request.GET.get("valid") == 'false':
            return super().get(request, *args, **kwargs)
        elif self.validate and not request.GET.get("valid") == 'true':
            return render(request, "base/validate.html", {"object": self.team, "action": self.action})
        else:
            self.apply_action(self.action)
            return super().get(request, *args, **kwargs)

event/templates/event/event_detail.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "Events" %}
{% endblock %}
{% block body %}

    <div class="row">
        <div class="col-10">
            <div class="card">
                <div class="card-header">
                    {{ object.name }}
                    <span class="float-right">
                    {% if object.owner == request.user %}
                        <a class="btn btn-sm btn-primary" href="{% url "event_remove" event_id=object.id %}"><small>
                                {% trans "Remove" %}
                        </small></a>
                        <a class="btn btn-sm btn-primary" href="{% url "event_edit" event_id=object.id %}"><small>
                                {% trans "Edit" %}
                        </small></a>
                    {% endif %}
                    </span>
                </div>
                <div class="card-body">
                    <p>{% trans "Location" %}: {{ object.location }}</p>
                    <p>{% trans "Date" %}: {{ object.date }}</p>
                    <p>{% trans "Description" %}: {{ object.description }}</p>
                </div>
            </div>
        </div>
        <div class="col-2">
            <h4>{% trans "Teams" %}</h4>
            <a class="btn btn-primary btn-sm" href="{% url "team_create" event_id=object.id %}">{% trans "Create" %}</a>
            <br>
            <br>
            {% for team in object.team_set.all %}
                <div class="card">
                    <div class="card-header">
                        <a href="{% url "team_detail" event_id=object.id team_id=team.id %}">{{ team.name }}</a>
                    </div>
                    <div class="card-body">
                        <ul>
                            {% for part in team.participation_set.all %}
                                <li>{% if team.owner == part.participant %}{% trans "Leader" %}: {% else %}{% trans "Participant" %}: {% endif %}<a href="{% url "user_detail" pk=part.participant.id %}">{{ part.participant.username }}</a></li>
                            {% endfor %}
                        </ul>
                    </div>
                </div>
            {% endfor %}
        </div>
    </div>
{% endblock %}

event/templates/event/event_form.html
{% extends "base/base.html" %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "New Event" %}
{% endblock %}
{% block body %}
    <div class="row">
        <div class="col-4 offset-4">
            <form method="POST">
                {% csrf_token %}
                {% bootstrap_form form %}
                {% trans "Create" as btn_content %}
                {% bootstrap_button content=btn_content button_type="submit" button_class="btn-primary btn-block" %}
            </form>
        </div>
    </div>
{% endblock %}

event/templates/event/event_list.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "Events" %}
{% endblock %}
{% block body %}
    <div class="card">
        <div class="card-body">
            <div class="row">
                <div class="col-1 offset-11">
                    <a class="btn btn-secondary btn-sm" href="{% url "event_create" %}">{% trans "Create" %}</a>
                </div>
            </div>
        </div>
    </div>
    <br>
    <div class="row">
        {% for event in object_list %}
            <div class="col-3">
                <div class="card">
                    <div class="card-header">
                        <a href="{% url "event_detail" event_id=event.id %}">{{ event.name }}</a>
                    </div>
                    <div class="card-body">
                        <p>{% trans "Location" %}: {{ event.location }}</p>
                        <p>{% trans "Date" %}: {{ event.date }}</p>
                        <p>{% trans "Description" %}: {{ event.description }}</p>
                    </div>
                </div>
            </div>
        {% endfor %}
    </div>
{% endblock %}

event/templates/event/participation_list.html
{% extends 'base/base.html' %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "Events" %}
{% endblock %}
{% block body %}
    <div class="row">
        <div class="col-12">
            <div class="card">
                <div class="card-header">
                    {{ team.name }}
                </div>
                <div class="card-body">
                    <ul>
                        {% for part in team.participation_set.all %}
                            <li>{% if team.owner == part.participant %}{% trans "Leader" %}:
                                {% else %}{% trans "Participant" %}: {% endif %}
                                <a href="{% url "user_detail" pk=part.participant.id %}">{{ part.participant.username }}</a>
                            </li>
                        {% endfor %}
                    </ul>
                    {% if request.user == team.owner %}
                        <a class="btn btn-secondary"
                           href="{% url "team_disband" event_id=team.event_id team_id=team.id %}">{% trans "Disband" %}</a>
                        <a class="btn btn-secondary"
                           href="{% url "team_edit" event_id=team.event_id team_id=team.id %}">{% trans "Edit" %}</a>
                    {% elif request.user.id not in users %}
                        <a class="btn btn-secondary"
                           href="{% url "team_join" event_id=team.event_id team_id=team.id %}">{% trans "Join" %}</a>
                    {% else %}
                        <a class="btn btn-secondary"
                           href="{% url "team_leave" event_id=team.event_id team_id=team.id %}">{% trans "Leave" %}</a>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
{% endblock %}

event/templates/event/team_form.html
{% extends "base/base.html" %}
{% load bootstrap4 i18n %}
{% block title %}
    {% trans "New Event" %}
{% endblock %}
{% block body %}
    <div class="row">
        <div class="col-4 offset-4">
            <form method="POST">
                {% csrf_token %}
                {% bootstrap_form form %}
                {% if object %}
                    {% trans "Update" as btn_content %}
                {% else %}
                    {% trans "Create" as btn_content %}
                {% endif %}
                {% bootstrap_button content=btn_content button_type="submit" button_class="btn-primary btn-block" %}
            </form>
        </div>
    </div>
{% endblock %}